Subject: bug#20105: 25.0.50; Emacs manual, `i HOME RET' sends you to `Moving Point', which is wrong

From: Drew Adams <[email-masked]>
Date: Sat, 14 Mar 2015 08:59:29 -0700 (PDT)

> > > > For `i home TAB' you see these candidates:
> > > > HOME
> > > > home directory shorthand
> > > >
> > > > In my setup I see also these two, but for some reason I don't see them
> > > > with `emacs -Q':
> > > > HOME directory on MS-Windows
> > > > HOME directory under MS-DOS
> > >
> > > I see all 4 of them in "emacs -Q".  Not sure why you don't; perhaps
> > > because your build is very old (but I doubt that).
> > No, I see only 2, even in this recent build (see end of this message).
> > > Do you have INFOPATH set in the environment, perhaps?
> > Nope.
> 
> Strange.  I have no idea why you see only 2 candidates.  I see all 4
> in both the master and emacs-24 branch.

I hear you.  I don't know why.  I'm on Windows 7 64-bit.  Other than
that, I don't know what else I can add here.

But see below.  I do have those two missing candidates as explicit
entries in the manual indexes.  It is completion that, for some reason,
fails to pick them up.  I don't see how you get different behavior, if
we're both using `emacs -Q'.

> > I agree about (a) case-insensitive "in general" and (b) users might not
> > know about `<home>' vs `home' vs `HOME'.
> >
> > But why is `HOME' capitalized as a candidate if it points to info about
> > the key?
> 
> Don't know.  Looks like some feature of completion.

Really?  My guess is instead that it comes from this explicit index
entry (which I see in Emacs 24 but not 23): (I removed some whitespace.)

* HOME:             Moving Point.        (line  57)

That's from the Key Index.  However, note that there are also these
two entries in the Variable Index, which seem not to be used when
I do `i home TAB':

* HOME:             General Variables.   (line  59)
* HOSTNAME:         General Variables.   (line  70)

(Got this from an Emacs 24.4 build.  I assume things are similar
for more recent builds.)

> > And we don't seem to have any entry currently for the env var (?).
> > Shouldn't a user be able to find some info about it?
> > `HOME environment variable', for example.
> 
> That's one of the 2 "HOME" entries.  They belong to different indices,
> so they are identical (and collapsed by completion into a single
> completion candidate, I presume).

Sorry, I don't know what you mean here.  I'm guessing that you're
saying something (?) about these entries (again, from Emacs 24.4):

* HOME directory on MS-Windows:      Windows HOME.        (line   6)
* home directory shorthand:          Minibuffer File.     (line  38)
* HOME directory under MS-DOS:       MS-DOS File Names.   (line  35)

>From what I see, the only explicit index entries that include `HOME'
(capitalized) refer to the home directory, not to the <home> key.

So it seems to me that Emacs is not correctly dealing with its own
index entries.  It also seems that the Key Index somehow overrides
the Variable Index (instead of being augmented by it), for completion.

HTH.